<?php
/* vim: set expandtab tabstop=4 shiftwidth=4 softtabstop=4: */
// +----------------------------------------------------------------------+
// | PHP version 5                                                        |
// +----------------------------------------------------------------------+
// | Copyright 2005-2006 the Seasar Foundation and the Others.            |
// +----------------------------------------------------------------------+
// | Licensed under the Apache License, Version 2.0 (the "License");      |
// | you may not use this file except in compliance with the License.     |
// | You may obtain a copy of the License at                              |
// |                                                                      |
// |     http://www.apache.org/licenses/LICENSE-2.0                       |
// |                                                                      |
// | Unless required by applicable law or agreed to in writing, software  |
// | distributed under the License is distributed on an "AS IS" BASIS,    |
// | WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND,                        |
// | either express or implied. See the License for the specific language |
// | governing permissions and limitations under the License.             |
// +----------------------------------------------------------------------+
// | Authors: klove                                                       |
// +----------------------------------------------------------------------+
//
// $Id: S2Container_Annotations.class.php 240 2006-03-27 13:08:38Z klove $
/**
 * @package org.seasar.extension.annotation
 * @author klove
 */
final class S2Container_Annotations 
{
    private function __construct() 
    {
    }
    
    /**
     * @param string or ReflectionClass $classKey
     * @param string $methodName
     * @param string $srcFile
     */
    public static function getAnnotations($classKey,
                                          $methodName = null,
                                          $srcFile = null)
    {
        $container = S2Container_AnnotationContainer::getInstance();
        return $container->getAnnotations($classKey,$methodName,$srcFile);
    }

    /**
     * @param string $annotationType
     * @param string or ReflectionClass $classKey
     * @param string $methodName
     * @param string $srcFile
     */
    public static function getAnnotation($annotationType,
                                         $classKey,
                                         $methodName = null,
                                         $srcFile = null)
    {
        $container = S2Container_AnnotationContainer::getInstance();
        return $container->getAnnotation($annotationType,
                                         $classKey,
                                         $methodName,
                                         $srcFile);
    }

    /**
     * @param string $annotationType
     * @param string or ReflectionClass $classKey
     * @param string $methodName
     * @param string $srcFile
     */
    public static function isAnnotationPresent($annotationType,
                                               $classKey,
                                               $methodName = null,
                                               $srcFile = null)
    {
        $container = S2Container_AnnotationContainer::getInstance();
        return $container->isAnnotationPresent($annotationType,
                                               $classKey,
                                               $methodName,
                                               $srcFile);
    }
}
?>
